/*
 * stalk/include.h
 * Copyright (c) 1993 Gerald Weiler
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef ___Inc__
#define ___Inc__

#include "config.h"

/* Sun's cc doesn't like #error, but STDC compiler grok the following: */
#ifdef SYSVTTY
# if defined (POSIXTTY) || defined(BSDTTY)
 #error You can only define one of the following: SYSVTTY, POSIXTTY, BSDTTY
# endif
#else
# ifdef POSIXTTY
#  ifdef BSDTTY
 #error You can only define one of the following: SYSVTTY, POSIXTTY, BSDTTY
#  endif
# else
#  ifndef BSDTTY
 #error You must define one of the following: SYSVTTY, POSIXTTY, BSDTTY
#  endif
# endif
#endif

#include <stdlib.h>

#ifdef DEBUG_MEM
#include "malloc.h"
#endif

#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/times.h>
#include <ctype.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <fcntl.h>
#include <dirent.h>
#include <sys/stat.h>
#include <pwd.h>
#include <grp.h>
#include <time.h>

#ifndef NeXT
# include <unistd.h>
#endif

#ifdef __STDC__
# include <stdarg.h>
# define VA_START(args, form) va_start(args, form)
# define P(x) x
#else
# include <varargs.h>
# define VA_START(args, form) va_start(args)
# define P(x) ()
#endif

#ifdef SYSVTTY
# include <termio.h>
# include <stropts.h>
#endif
#ifdef POSIXTTY
# include <termios.h>
#endif
#ifdef BSDTTY
# include <sgtty.h>
#endif

#ifndef CONFIG_STALK
# define CONFIG_STALK "/dev/null"
#endif

extern char *tgoto(), *tgetstr(), *getenv();
extern int tgetent(), tgetnum(), tputs();
#ifdef putchar
# undef putchar
#endif
extern int putchar();

#include "structures.h"

#ifdef sun
extern time_t	time P((time_t *));
extern size_t	strftime P((char *s, size_t smax, const char *fmt,
			    const struct tm *tp));
#endif
/* end of my-time */

#define NEW(type) (type *)malloc(sizeof(type))

/* screentypes */
#define TERM_DUMB    1
#define TERM_TERMCAP 2
#define TERM_X       3

#define TRUE  1
#define FALSE 0

#ifdef MIN
#undef MIN
#endif
#define MIN(x, y) (((x) < (y)) ? (x) : (y))

#ifdef MAX
#undef MAX
#endif
#define MAX(x, y) (((x) > (y)) ? (x) : (y))

/* file descriptors for stdin, stdout, and stderr */
#define FD_IN  0
#define FD_OUT 1
#define FD_ERR 2

#ifdef NEED_INT_DEFINES
int sscanf();
int printf();
int fclose();
int fprintf();
#ifndef bzero
int bzero();
#endif
int select();
int fflush();
int vfprintf();
int tolower();
int ioctl();
int fputs();
int vsprintf();
int fgetc();
#endif

#endif /* ___Inc__ */
