/*
 * stalk/interpret.h
 */

#ifndef INTERPRET_H
#define INTERPRET_H

var *in_pop                   P((task *t));
void in_push                  P((task *t, var *v));
void ntrp_task                P((task *t));

void ntrp_noop                P((task *t));
void ntrp_jump                P((task *t));
void ntrp_if                  P((task *t));
void ntrp_while               P((task *t));
void ntrp_endwhile            P((task *t));
void ntrp_exit                P((task *t));
void ntrp_return              P((task *t));
void ntrp_empty_return        P((task *t));
void ntrp_for_list            P((task *t));
void ntrp_for_range           P((task *t));
void ntrp_endfor              P((task *t));
void ntrp_fork                P((task *t));
void ntrp_endfork             P((task *t));
void ntrp_identifier          P((task *t));
void ntrp_local_variable      P((task *t));
void ntrp_global_variable     P((task *t));
void ntrp_value               P((task *t));
void ntrp_end_expression      P((task *t));
void ntrp_element             P((task *t));
void ntrp_element_range       P((task *t));
void ntrp_single_elt_list     P((task *t));
void ntrp_combine_lists       P((task *t));
void ntrp_splice_lists        P((task *t));
void ntrp_empty_list          P((task *t));
void ntrp_local_assign        P((task *t));
void ntrp_global_assign       P((task *t));
void ntrp_end_assign          P((task *t));
void ntrp_function            P((task *t));
void ntrp_conditional         P((task *t));
void ntrp_equal               P((task *t));
void ntrp_not_equal           P((task *t));
void ntrp_greater_equal       P((task *t));
void ntrp_greater_than        P((task *t));
void ntrp_less_equal          P((task *t));
void ntrp_less_than           P((task *t));
void ntrp_add                 P((task *t));
void ntrp_sub                 P((task *t));
void ntrp_mul                 P((task *t));
void ntrp_div                 P((task *t));
void ntrp_mod                 P((task *t));
void ntrp_negate              P((task *t));
void ntrp_not                 P((task *t));
void ntrp_or                  P((task *t));
void ntrp_and                 P((task *t));
void ntrp_or_ss               P((task *t));
void ntrp_and_ss              P((task *t));
void ntrp_in                  P((task *t));
void ntrp_line_info           P((task *t));
void ntrp_debug               P((task *t));
void ntrp_end_debug           P((task *t));
void ntrp_debug_call          P((task *t));
void ntrp_debug_ignore        P((task *t));
void ntrp_debug_fatal         P((task *t));

#ifdef EVIL_DEBUGGING_MODE
void dump_program             P((statement *s));
void dump_stack               P((FILE *f, var_stack *vs));
void dump_var                 P((FILE *f, var *v, int indent));
#endif /* EVIL_DEBUGGING_MODE */

extern int debug_dump;

#endif /* INTERPRET_H */
