/*
 * stalk/stream.h
 */

#ifndef STREAM_H
#define STREAM_H

#define ALL_TASKS -1

stream *newstream             P((task *t, buffer *buf));
stream *findstream            P((task *t, int n));
void init_streams          P((buffer *buf));
void freestream               P((stream *s));
void stream_close             P((stream *s));
void check_streams            P((int maxtimeout));
void process_input            P((stream *s));
void debit_stream_time        P((stream *s));
void stream_read              P((stream *s));
void send_to_streams          P((buffer *buf, int task_id, char *string));
void free_task_streams        P((buffer *buf, int task_id));
int stream_readchar           P((stream *s, int timeout));
int new_cstream               P((buffer *buf, char *name, int port));

void bi_popen                 P((task *t, var *args));
void bi_fopen                 P((task *t, var *args));
void bi_copen                 P((task *t, var *args));
void bi_sopen                 P((task *t, var *args));
void bi_accept                P((task *t, var *args));
void bi_close                 P((task *t, var *args));
void bi_read                  P((task *t, var *args));
void bi_write                 P((task *t, var *args));
void bi_set_timeout           P((task *t, var *args));
void bi_capture_output        P((task *t, var *args));
void bi_export                P((task *t, var *args));
void bi_on_input              P((task *t, var *args));
void bi_on_close              P((task *t, var *args));
void bi_broadcast             P((task *t, var *args));
void bi_set_mode              P((task *t, var *args));
void bi_streams               P((task *t, var *args));
void bi_stream_ready          P((task *t, var *args));

#endif /* STREAM_H */
