/*
 * stalk/task.h
 */

#ifndef TASK_H
#define TASK_H

void init_tasks               P((void));
void task_free                P((task *t));
void exec_builtin             P((prog_env *penv, char *name, task *t,
                                 var *args));
void exec_task                P((task *t, program *p, var *args, int debug));
void push_task                P((buffer *buf, program *p, var *args));
void fork_task                P((buffer *buf, program *p, statement *s,
                                 int delay));
void send_buffer_event        P((buffer *buf, char *event, int eval));
void wake_task                P((task *t));
program *find_program         P((prog_env *penv, char *name));
int func_exists               P((prog_env *penv, char *name));
int check_tasks               P((void));
task *new_task                P((buffer *buf));

void bi_ticks_left            P((task *t, var *args));
void bi_set_ticks             P((task *t, var *args));
void bi_default_ticks         P((task *t, var *args));
void bi_task_id               P((task *t, var *args));
void bi_suspend               P((task *t, var *args));
void bi_die                   P((task *t, var *args));
void bi_kill_task             P((task *t, var *args));
void bi_queued_tasks          P((task *t, var *args));

#endif /* TASK_H */
